local hcTk = HCToolkit
local GetInspectSpecialization = GetInspectSpecialization

function hcTk.UnitClassColor(unit)
    local color = RAID_CLASS_COLORS[select(2, UnitClass(unit))];
    if (color == nil) then
      return "ffffffff"
    end
    return color.colorStr
end

function hcTk.UnitCreatePlayer(unit)
    local player = {};
    player["alive"] = true
    player["name"] = string.gsub(GetUnitName(unit, false), "%-[^|]+", "")
    player["class"] = UnitClass(unit)
    player["classColor"] = hcTk.UnitClassColor(unit)
    player["unit"] = unit
    player["version"] = "Unknown"
    return player;
end

function hcTk.UnitSetDead(guid)
    if (hcTk.Group[guid] ~= nil) then
        hcTk.Group[guid]["alive"] = false
        C_Timer.After(1, function() hcTk.UnitUpdateAlive(guid) end)
    end
end

function hcTk.UnitUpdateAlive(guid)
    if (hcTk.Group[guid] ~= nil) then
        -- Check If Unit Is Alive
        local player = hcTk.Group[guid]
        player["alive"] = not UnitIsDeadOrGhost(player["unit"])

        if (player["alive"] == false) then
            C_Timer.After(1, function() hcTk.UnitUpdateAlive(guid) end)
        end
    end
end

function hcTk.UnitUpdateRole(guid, specId)
    if (hcTk.Group[guid] ~= nil) then
        hcTk.Group[guid]["role"] = hcTk.SpecializationGetRole(specId)
    end
end

function hcTk.UnitUpdateVersion(guid, version)
    if (hcTk.Group[guid] ~= nil) then
        hcTk.Group[guid]["version"] = version
    end
end

function hcTk.UnitPlayerString(player)
    if (player["name"] == "Unknown") then
        hcTk.UnitUpdateInformation(player)
    end

    return string.format("|c%s%s|r", player["classColor"], player["name"]);
end

function hcTk.UnitUpdateInformation(player)
    player["name"] = string.gsub(GetUnitName(player["unit"], false), "%-[^|]+", "")
    player["class"] = UnitClass(player["unit"])
    player["classColor"] = hcTk.UnitClassColor(player["unit"])
end